#include <cstdlib>
#include <iostream> 
using namespace std;

// Classe Persoangem  - Classe Abstrata
class Personagem
{     protected: int id;     
      public:
             Personagem(int i = -1){ setId(i); }                      
             ~Personagem(){ }
             void setId(int i) { id = i; }
             int getId(){ return id; }
             virtual void informe_papel()=0;  // virtual puro - portanto classe abstrata
};

// Classe Jogador
class Jogador : public Personagem
{     private:
            string nome;
            static int total_jogs;
      public:    
            Jogador(int i=-1, string n= ""):Personagem(i) { total_jogs ++; setNome( n ); }
           ~Jogador(){}
           void informe_papel()      { cout << "mocinho" << endl; }
           void setNome(string n)    { nome = n; }
           string getNome()          { return nome; }
           static int getTotalJogs() { return total_jogs; }  // mtodo esttico
};
// inicializao de atributo esttico
int Jogador::total_jogs = 0;
             
// Classe Elemento 
class Inimigo : public Personagem
{     private: int tipo;
      public:
            Inimigo(int i=-1, int t=-1) : Personagem(i) { setTipo( t ); }
            ~Inimigo(){ }
            void informe_papel()  { cout << "bandido" << endl; }
            void setTipo(int t)   { tipo = t; }
            int getTipo()         { return tipo; }
};

// Classe Elemento 
template<class TIPO> 
class Elemento
{   private:
        Elemento<TIPO>* prox;
        TIPO *inf;       
    public:
        Elemento() { prox = NULL; inf = NULL; }
        ~Elemento(){ }      
        void setProx(Elemento<TIPO>* p)   { prox = p;    } 
        Elemento<TIPO>* getProx()         { return prox; }
        void setInf(TIPO* i)              { inf = i;     }
        TIPO* getInf()                    { return inf;  }
};

// Classe Lista_Personagens
class Lista_Pers
{   private:
        Elemento<Personagem> *prim;
        Elemento<Personagem> *atual;
    public:
        Lista_Pers() { prim = atual = NULL; }
        ~Lista_Pers(){ limparLista(); }
        void incluirPersonagem(Personagem *p) 
        {
            if ( p == NULL ){ cout << "Erro ao inserir personagem!" << endl; return; }

            Elemento<Personagem>* novo = new Elemento<Personagem>;         
            novo->setInf( p );
            
            if (NULL == prim){ 
                 prim = atual = novo; 
            } 
            else{  
                 atual->setProx( novo ); atual = atual->getProx(); 
            }    
        }

        void listarPersonagens()
        {    Elemento<Personagem> *aux = prim;
             Personagem *per;    
             while(aux != NULL)
             {
                 per = aux->getInf();
                 
                 cout << per->getId() << "\t-\t";
                 
                 per->informe_papel();
                 
                 aux = aux->getProx();
             }
        }

        void limparLista()
        {
            Elemento<Personagem> *aux;
            while (prim != NULL) {
                   aux = prim->getProx();    
                   delete prim;
                   prim = aux;
            }    
            prim = atual = NULL;
        }
};

// Classe Principal_Jogo
class Principal_Jogo
{    private:
        Lista_Pers obj_Lista_P_1;
    
    public:
        Principal_Jogo()  { menu(); }
        ~Principal_Jogo() {}
        
        void menu() 
        {   char op;
            do{        
                  cout << "(1)Criar Jog" << endl;
                  cout << "(2)Criar Inim" << endl;
                  cout << "(3)Listar Pers" << endl;
                  cout << "(4)Quant Jogs" << endl;
                  cout << "(5)Sair" << endl;
                  cout << "Opcao: ";
                  cin >> op;
        
                  switch( op )
                  {
                        case '1': criarJogador();                    break;
                        case '2': criarInimigo();                    break;
                        case '3': listarPersonagem();                break;
                        case '4': qtdJogadores();                    break;
                        case '5':                                    break;
                        default:  cout << "Opcao invalida!" << endl; break;
                  }                    
                  system("pause"); system("cls");                    
            }while( op != '5');
        }

        void criarJogador()
        {
            int id;  string nome;
            
            cout << "Informe o codigo: ";
            cin >> id;  
            fflush(stdin);

            cout << "Informe o nome do jogador: ";
            getline(cin, nome, '\n');
            
            Jogador *novo = new Jogador(id, nome);
            
            obj_Lista_P_1.incluirPersonagem( novo );
        }

        void criarInimigo()
        {
           int id;
           int tipo;
    
           cout << "Informe o codigo: ";
           cin >> id; fflush(stdin);
        
           cout << "Informe o tipo do inimigo: ";
           cin >> tipo;
    
           Inimigo *novo = new Inimigo(id, tipo);
           
           obj_Lista_P_1.incluirPersonagem( novo );
        }
        
        void listarPersonagem()
        {
            cout << "Lista de personagens: " << endl;
            obj_Lista_P_1.listarPersonagens();
        }

        void qtdJogadores()
        {
            cout << "Jogadores: " << Jogador::getTotalJogs() << endl;
        }
};

int main()
{   
    Principal_Jogo principal;
    return 0;
}

